require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_xiiscertsbinding',
  dscmeta_resource_friendly_name: 'xIISCertSBinding',
  dscmeta_resource_name: 'xIISCertSBinding',
  dscmeta_resource_implementation: 'MOF',
  dscmeta_module_name: 'xIISCertSBinding',
  dscmeta_module_version: '1.0.0.1',
  docs: 'The DSC xIISCertSBinding resource type.
         Automatically generated from version 1.0.0.1',
  features: ['simple_get_filter', 'canonicalize', 'custom_insync'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    validation_mode: {
      type:      'Enum[property, resource]',
      desc:      'Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode (resource).',
      behaviour: :parameter,
      default:   'property',
    },
    dsc_port: {
      type: 'Integer[0, 65535]',
      desc: '????',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'UInt16',
      mof_is_embedded: false,
    },
    dsc_certthumbprint: {
      type: 'String',
      desc: '????',

      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_ip: {
      type: 'String',
      desc: '??IP',

      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_bindingurl: {
      type: 'String',
      desc: ' ',

      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
